import React from 'react';
import SplitButton from '../SplitButton';
import OverflowMenuItem from '../OverflowMenuItem';
import Button from '../Button';
import OverflowMenu from '../OverflowMenu';
import { shallow } from 'enzyme';
describe('SplitButton', function () {
  describe('renders as expected', function () {
    var wrapper = shallow(React.createElement(SplitButton, {
      classNameContainer: 'extra-class',
      classNameButton: 'extra-class',
      classNameOverflow: 'extra-class'
    }, React.createElement(OverflowMenuItem, {
      itemText: 'Item 1'
    }), React.createElement(OverflowMenuItem, {
      itemText: 'Item 2',
      primaryFocus: true
    }), React.createElement(OverflowMenuItem, {
      itemText: 'Item 2'
    })));
    it('renders children as expected', function () {
      expect(wrapper.props().children.length).toEqual(2);
    });
    it('renders extra classes as expected', function () {
      expect(wrapper.hasClass('extra-class')).toEqual(true);
      expect(wrapper.find(Button).shallow().hasClass('extra-class')).toEqual(true);
      expect(wrapper.find(OverflowMenu).shallow().hasClass('extra-class')).toEqual(true);
    });
  });
});